/*
 * Copyright (C) 2015 Nu Development Team
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package com.nubits.nubot.models;


import java.util.ArrayList;

public class CurrencyList {


    //Nu currencies
    public static Currency USNBT;
    public static Currency CNNBT;
    public static Currency EUNBT;
    public static Currency XNBT;

    //currency lists
    public static ArrayList<Currency> allCurrencies = new ArrayList<>();
    public static ArrayList<Currency> nuCurrencies = new ArrayList<>();
    public static ArrayList<CurrencyPair> allPairs = new ArrayList<>();
    public static ArrayList<CurrencyPair> supportedPairs = new ArrayList<>();

    //fiat
    public static Currency USD;
    public static Currency CNY;
    public static Currency EUR;
    public static Currency PHP;
    public static Currency JPY;
    public static Currency HKD;

    //crypto
    public static Currency BTC;
    public static Currency NSR;
    public static Currency PPC;
    public static Currency LTC;
    public static Currency DOGE;
    public static Currency ETH;
    public static Currency XRP;
    public static Currency BCH;

    //Unkwnown
    public static Currency UNKNOWN;

    //us-nbt fiat pairs
    public static CurrencyPair USNBT_USD;
    public static CurrencyPair USD_USNBT;

    public static CurrencyPair USNBT_EUR;
    public static CurrencyPair USNBT_CNY;
    public static CurrencyPair USNBT_JPY;
    public static CurrencyPair USNBT_PHP;
    public static CurrencyPair USNBT_HKD;

    //cn-nbt fiat pairs
    public static CurrencyPair CNNBT_CNY;
    public static CurrencyPair CNY_CNNBT;

    public static CurrencyPair CNNBT_USD;
    public static CurrencyPair CNNBT_EUR;
    public static CurrencyPair CNNBT_JPY;
    public static CurrencyPair CNNBT_PHP;
    public static CurrencyPair CNNBT_HKD;

    //eu-nbt fiat pairs
    public static CurrencyPair EUNBT_EUR;
    public static CurrencyPair EUR_EUNBT;

    public static CurrencyPair EUNBT_USD;
    public static CurrencyPair EUNBT_CNY;
    public static CurrencyPair EUNBT_JPY;
    public static CurrencyPair EUNBT_PHP;
    public static CurrencyPair EUNBT_HKD;

    //x-nbt fiat pairs
    public static CurrencyPair XNBT_USD;
    public static CurrencyPair XNBT_EUR;
    public static CurrencyPair XNBT_CNY;
    public static CurrencyPair XNBT_JPY;
    public static CurrencyPair XNBT_PHP;
    public static CurrencyPair XNBT_HKD;

    //fiat to fiat pairs
    public static CurrencyPair EUR_USD;
    public static CurrencyPair CNY_USD;
    public static CurrencyPair PHP_USD;
    public static CurrencyPair HKD_USD;
    public static CurrencyPair JPY_USD;

    //us-nbt crypto pairs
    public static CurrencyPair USNBT_BTC;
    public static CurrencyPair USNBT_PPC;

    //cn-nbt crypto pairs
    public static CurrencyPair CNNBT_BTC;
    public static CurrencyPair CNNBT_PPC;

    //eu-nbt crypto pairs
    public static CurrencyPair EUNBT_BTC;
    public static CurrencyPair EUNBT_PPC;

    //x-nbt crypto pairs
    public static CurrencyPair XNBT_BTC;
    public static CurrencyPair XNBT_PPC;

    //swapped crypto us-nbt pairs
    public static CurrencyPair BTC_USNBT;
    public static CurrencyPair LTC_USNBT;
    public static CurrencyPair XRP_USNBT;
    public static CurrencyPair ETH_USNBT;
    public static CurrencyPair BCH_USNBT;

    //swapped crypto cn-nbt pairs
    public static CurrencyPair BTC_CNNBT;
    public static CurrencyPair LTC_CNNBT;
    public static CurrencyPair XRP_CNNBT;
    public static CurrencyPair ETH_CNNBT;

    //swapped crypto eu-nbt pairs
    public static CurrencyPair BTC_EUNBT;
    public static CurrencyPair LTC_EUNBT;
    public static CurrencyPair XRP_EUNBT;
    public static CurrencyPair ETH_EUNBT;

    //swapped crypto x-nbt pairs
    public static CurrencyPair BTC_XNBT;
    public static CurrencyPair LTC_XNBT;
    public static CurrencyPair XRP_XNBT;
    public static CurrencyPair ETH_XNBT;

    //other pairs
    public static CurrencyPair XRP_BTC;
    public static CurrencyPair ETH_BTC;
    public static CurrencyPair LTC_BTC;
    public static CurrencyPair BTC_USD;
    public static CurrencyPair PPC_USD;
    public static CurrencyPair ETH_USD;
    public static CurrencyPair XRP_USD;
    public static CurrencyPair LTC_USD;
    public static CurrencyPair PPC_BTC;
    public static CurrencyPair PPC_LTC;
    public static CurrencyPair BTC_CNY;
    public static CurrencyPair DOGE_BTC;

    //Unknown
    public static CurrencyPair UNKNOWPAIR;


    static {

        USD = Currency.createCurrency("USD");
        allCurrencies.add(USD);

        CNY = Currency.createCurrency("CNY");
        allCurrencies.add(CNY);

        EUR = Currency.createCurrency("EUR");
        allCurrencies.add(EUR);

        PHP = Currency.createCurrency("PHP");
        allCurrencies.add(PHP);

        HKD = Currency.createCurrency("HKD");
        allCurrencies.add(HKD);

        JPY = Currency.createCurrency("JPY");
        allCurrencies.add(JPY);

        BTC = Currency.createCurrency("BTC");
        allCurrencies.add(BTC);

        USNBT = Currency.createCurrency("USNBT");
        allCurrencies.add(USNBT);

        CNNBT = Currency.createCurrency("CNNBT");
        allCurrencies.add(CNNBT);

        EUNBT = Currency.createCurrency("EUNBT");
        allCurrencies.add(EUNBT);

        XNBT = Currency.createCurrency("XNBT");
        allCurrencies.add(XNBT);

        NSR = Currency.createCurrency("NSR");
        allCurrencies.add(NSR);

        PPC = Currency.createCurrency("PPC");
        allCurrencies.add(PPC);

        LTC = Currency.createCurrency("LTC");
        allCurrencies.add(LTC);

        DOGE = Currency.createCurrency("DOGE");
        allCurrencies.add(DOGE);

        XRP = Currency.createCurrency("XRP");
        allCurrencies.add(XRP);

        ETH = Currency.createCurrency("ETH");
        allCurrencies.add(ETH);

        BCH = Currency.createCurrency("BCH");
        allCurrencies.add(BCH);

        UNKNOWN = new Currency(false, "???", "Unknown currency", "", new ArrayList<>());
        allCurrencies.add(UNKNOWN);

        // List NuCurrencies
        nuCurrencies.add(USNBT);
        nuCurrencies.add(CNNBT);
        nuCurrencies.add(EUNBT);
        nuCurrencies.add(XNBT);

        //US-NBT
        USNBT_USD = new CurrencyPair(USNBT, USD);
        allPairs.add(USNBT_USD);

        USD_USNBT = new CurrencyPair(USD, USNBT);
        allPairs.add(USD_USNBT);

        USNBT_BTC = new CurrencyPair(USNBT, BTC);
        allPairs.add(USNBT_BTC);

        BTC_USNBT = new CurrencyPair(BTC, USNBT);
        allPairs.add(BTC_USNBT);

        USNBT_PPC = new CurrencyPair(USNBT, PPC);
        allPairs.add(USNBT_PPC);

        USNBT_EUR = new CurrencyPair(USNBT, EUR);
        allPairs.add(USNBT_EUR);

        USNBT_CNY = new CurrencyPair(USNBT, CNY);
        allPairs.add(USNBT_CNY);

        USNBT_JPY = new CurrencyPair(USNBT, JPY);
        allPairs.add(USNBT_JPY);

        USNBT_PHP = new CurrencyPair(USNBT, PHP);
        allPairs.add(USNBT_PHP);

        USNBT_HKD = new CurrencyPair(USNBT, HKD);
        allPairs.add(USNBT_HKD);

        ETH_USNBT = new CurrencyPair(ETH, USNBT);
        allPairs.add(ETH_USNBT);

        BCH_USNBT = new CurrencyPair(BCH, USNBT);
        allPairs.add(BCH_USNBT);

        LTC_USNBT = new CurrencyPair(LTC, USNBT);
        allPairs.add(LTC_USNBT);

        XRP_USNBT = new CurrencyPair(XRP, USNBT);
        allPairs.add(XRP_USNBT);

        //CN-NBT
        CNNBT_USD = new CurrencyPair(CNNBT, USD);
        allPairs.add(CNNBT_USD);

        CNNBT_BTC = new CurrencyPair(CNNBT, BTC);
        allPairs.add(CNNBT_BTC);

        BTC_CNNBT = new CurrencyPair(BTC, CNNBT);
        allPairs.add(BTC_CNNBT);

        CNNBT_PPC = new CurrencyPair(CNNBT, PPC);
        allPairs.add(CNNBT_PPC);

        CNNBT_EUR = new CurrencyPair(CNNBT, EUR);
        allPairs.add(CNNBT_EUR);

        CNNBT_CNY = new CurrencyPair(CNNBT, CNY);
        allPairs.add(CNNBT_CNY);

        CNY_CNNBT = new CurrencyPair(CNY, CNNBT);
        allPairs.add(CNY_CNNBT);

        CNNBT_JPY = new CurrencyPair(CNNBT, JPY);
        allPairs.add(CNNBT_JPY);

        CNNBT_PHP = new CurrencyPair(CNNBT, PHP);
        allPairs.add(CNNBT_PHP);

        CNNBT_HKD = new CurrencyPair(CNNBT, HKD);
        allPairs.add(CNNBT_HKD);

        ETH_CNNBT = new CurrencyPair(ETH, CNNBT);
        allPairs.add(ETH_CNNBT);

        LTC_CNNBT = new CurrencyPair(LTC, CNNBT);
        allPairs.add(LTC_CNNBT);

        XRP_CNNBT = new CurrencyPair(XRP, CNNBT);
        allPairs.add(XRP_CNNBT);

        //EU-NBT
        EUNBT_USD = new CurrencyPair(EUNBT, USD);
        allPairs.add(EUNBT_USD);

        EUNBT_BTC = new CurrencyPair(EUNBT, BTC);
        allPairs.add(EUNBT_BTC);

        BTC_EUNBT = new CurrencyPair(BTC, EUNBT);
        allPairs.add(BTC_EUNBT);

        EUNBT_PPC = new CurrencyPair(EUNBT, PPC);
        allPairs.add(EUNBT_PPC);

        EUNBT_EUR = new CurrencyPair(EUNBT, EUR);
        allPairs.add(EUNBT_EUR);

        EUR_EUNBT = new CurrencyPair(EUR, EUNBT);
        allPairs.add(EUR_EUNBT);

        EUNBT_CNY = new CurrencyPair(EUNBT, CNY);
        allPairs.add(EUNBT_CNY);

        EUNBT_JPY = new CurrencyPair(EUNBT, JPY);
        allPairs.add(EUNBT_JPY);

        EUNBT_PHP = new CurrencyPair(EUNBT, PHP);
        allPairs.add(EUNBT_PHP);

        EUNBT_HKD = new CurrencyPair(EUNBT, HKD);
        allPairs.add(EUNBT_HKD);

        ETH_EUNBT = new CurrencyPair(ETH, EUNBT);
        allPairs.add(ETH_EUNBT);

        LTC_EUNBT = new CurrencyPair(LTC, EUNBT);
        allPairs.add(LTC_EUNBT);

        XRP_EUNBT = new CurrencyPair(XRP, EUNBT);
        allPairs.add(XRP_EUNBT);

        //X-NBT
        XNBT_USD = new CurrencyPair(XNBT, USD);
        allPairs.add(XNBT_USD);

        XNBT_BTC = new CurrencyPair(XNBT, BTC);
        allPairs.add(XNBT_BTC);

        BTC_XNBT = new CurrencyPair(BTC, XNBT);
        allPairs.add(BTC_XNBT);

        XNBT_PPC = new CurrencyPair(XNBT, PPC);
        allPairs.add(XNBT_PPC);

        XNBT_EUR = new CurrencyPair(XNBT, EUR);
        allPairs.add(XNBT_EUR);

        XNBT_CNY = new CurrencyPair(XNBT, CNY);
        allPairs.add(XNBT_CNY);

        XNBT_JPY = new CurrencyPair(XNBT, JPY);
        allPairs.add(XNBT_JPY);

        XNBT_PHP = new CurrencyPair(XNBT, PHP);
        allPairs.add(XNBT_PHP);

        XNBT_HKD = new CurrencyPair(XNBT, HKD);
        allPairs.add(XNBT_HKD);

        ETH_XNBT = new CurrencyPair(ETH, XNBT);
        allPairs.add(ETH_XNBT);

        LTC_XNBT = new CurrencyPair(LTC, XNBT);
        allPairs.add(LTC_XNBT);

        XRP_XNBT = new CurrencyPair(XRP, XNBT);
        allPairs.add(XRP_XNBT);

        // currencies
        BTC_USD = new CurrencyPair(BTC, USD);
        allPairs.add(BTC_USD);

        PPC_USD = new CurrencyPair(PPC, USD);
        allPairs.add(PPC_USD);

        ETH_USD = new CurrencyPair(ETH, USD);
        allPairs.add(ETH_USD);

        XRP_USD = new CurrencyPair(XRP, USD);
        allPairs.add(XRP_USD);

        LTC_USD = new CurrencyPair(LTC, USD);
        allPairs.add(LTC_USD);

        PPC_BTC = new CurrencyPair(PPC, BTC);
        allPairs.add(PPC_BTC);

        PPC_LTC = new CurrencyPair(PPC, LTC);
        allPairs.add(PPC_LTC);

        BTC_CNY = new CurrencyPair(BTC, CNY);
        allPairs.add(BTC_CNY);

        EUR_USD = new CurrencyPair(EUR, USD);
        allPairs.add(EUR_USD);

        CNY_USD = new CurrencyPair(CNY, USD);
        allPairs.add(CNY_USD);

        PHP_USD = new CurrencyPair(PHP, USD);
        allPairs.add(PHP_USD);

        HKD_USD = new CurrencyPair(HKD, USD);
        allPairs.add(HKD_USD);

        JPY_USD = new CurrencyPair(JPY, USD);
        allPairs.add(JPY_USD);

        LTC_BTC = new CurrencyPair(LTC, BTC);
        allPairs.add(LTC_BTC);

        DOGE_BTC = new CurrencyPair(DOGE, BTC);
        allPairs.add(DOGE_BTC);

        ETH_BTC = new CurrencyPair(ETH, BTC);
        allPairs.add(ETH_BTC);

        LTC_BTC = new CurrencyPair(LTC, BTC);
        allPairs.add(LTC_BTC);

        XRP_BTC = new CurrencyPair(XRP, BTC);
        allPairs.add(XRP_BTC);

        UNKNOWPAIR = new CurrencyPair(UNKNOWN, UNKNOWN);
        allPairs.add(UNKNOWPAIR);

        //Pairs supported by NuBot
        //us-nbt
        supportedPairs.add(USNBT_USD);
        supportedPairs.add(USNBT_BTC);
        supportedPairs.add(USNBT_EUR);
        supportedPairs.add(USNBT_CNY);
        supportedPairs.add(USNBT_PPC);
        supportedPairs.add(USNBT_BTC);
        //swapped
        supportedPairs.add(BTC_USNBT);
        supportedPairs.add(LTC_USNBT);
        supportedPairs.add(XRP_USNBT);
        supportedPairs.add(ETH_USNBT);
        supportedPairs.add(BCH_USNBT);
        //cn-nbt
        supportedPairs.add(CNNBT_USD);
        supportedPairs.add(CNNBT_BTC);
        supportedPairs.add(CNNBT_EUR);
        supportedPairs.add(CNNBT_CNY);
        supportedPairs.add(CNNBT_PPC);
        supportedPairs.add(CNNBT_BTC);
        //swapped
        supportedPairs.add(BTC_CNNBT);
        supportedPairs.add(LTC_CNNBT);
        supportedPairs.add(XRP_CNNBT);
        supportedPairs.add(ETH_CNNBT);
        //eu-nbt
        supportedPairs.add(EUNBT_USD);
        supportedPairs.add(EUNBT_BTC);
        supportedPairs.add(EUNBT_EUR);
        supportedPairs.add(EUNBT_CNY);
        supportedPairs.add(EUNBT_PPC);
        supportedPairs.add(EUNBT_BTC);
        //swapped
        supportedPairs.add(BTC_EUNBT);
        supportedPairs.add(LTC_EUNBT);
        supportedPairs.add(XRP_EUNBT);
        supportedPairs.add(ETH_EUNBT);
        //x-nbt
        supportedPairs.add(XNBT_USD);
        supportedPairs.add(XNBT_BTC);
        supportedPairs.add(XNBT_EUR);
        supportedPairs.add(XNBT_CNY);
        supportedPairs.add(XNBT_PPC);
        supportedPairs.add(XNBT_BTC);
        //swapped
        supportedPairs.add(BTC_XNBT);
        supportedPairs.add(LTC_XNBT);
        supportedPairs.add(XRP_XNBT);
        supportedPairs.add(ETH_XNBT);

    }

    public static boolean isPairSupported(CurrencyPair pair) {
        for (int i = 0; i < supportedPairs.size(); i++) {
            if (pair.equals(supportedPairs.get(i))) {
                return true;
            }
        }
        return false;
    }


}
